/*
updtprv.c Version 0.1.0  Btree update the test database
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/* Usage: updtprv filename */

#include <bthash.h>

void putstx(char *pgm)
   {
   fprintf(stderr,"Usage: %s filename\n", pgm);
   exit(1);
   } /* putstx */

int main(int argc, char **argv)
   {
   int opnerr;
   int rslt;
   int gnrslt;
   btreefmt *bthdr;
   unsigned char *p,*q,*r;
   unsigned char *keyptr;
   unsigned char *rcdptr;
   unsigned char str[4096];
   unsigned char buf[4096*8];
   char dbname[128];
   if (argc != 2) putstx(*argv);
   strcpy(dbname,*(argv+1));

   bthdr = (btreefmt *) btopen(dbname,UPDT,&opnerr);
   if (bthdr == NULL)
      {
      fprintf(stderr,"updtprv: open "
         "error %d\n", opnerr);
      return(0);
      } /* open error */
   /* process starts here */

   if (bthdr->keyofst < 1)
      {
      fprintf(stderr,"updtprv: keyofst %d\n",
         bthdr->keyofst);
      fprintf(stderr,"keyofst must be >= 1\n");
      fprintf(stderr,"First part of record must be data\n");
      fprintf(stderr,"updtprv changes this data part\n");
      fprintf(stderr,"Change tupdt.bat and re-run\n");
      btclose(bthdr);
      exit(1);
      } /* bad keyofst */
   /* first key for getnext is binary FF... */
   /* this starts reading at the end of the file */
   p = (unsigned char *) str;
   q = (unsigned char *) p + bthdr->keylen;
   while (p < q) *p++ = 255;

   rslt = 0;
   while (!rslt)
      {
      /* str is the key and buf is the output record */
      keyptr = (unsigned char *) str;
      rcdptr = (unsigned char *) buf;
      gnrslt = btgetprv(bthdr,ROOT,keyptr,rcdptr);
      /* exit loop at beginning of file */
      if (gnrslt) break;
      p = (unsigned char *) rcdptr;
      if (*(p + bthdr->dletofst) == DELETED)
         {
         fprintf(stderr,"updtprv: btgetprv "
            "ofst %08x rcdnum %d "
            "deleted index node\n",
            bthdr->ofst, bthdr->rcdnum);
         exit(1);
         } /* deleted record */
      /* replace first keyofst bytes of record */
      p = (unsigned char *) buf;
      q = (unsigned char *) p + bthdr->keyofst;
      while (p < q) *p++ = 'z';
      /* update the database */
      rslt = btupdt(bthdr,ROOT,rcdptr);
      if (rslt)
	 {
         fprintf(stderr,"btupdt: error "
            "rslt %d reason %d\n",
            rslt, bthdr->reason);
	 exit(1);
	 } /* btupdt err */
      /* copy new key to str */
      p = (unsigned char *) buf + bthdr->keyofst;;
      q = (unsigned char *) p + bthdr->keylen;
      r = (unsigned char *) str;
      while (p < q) *r++ = *p++;
      *r = '\0';
      /* repeat loop */
      } /* insert loop */
   fprintf(stderr,"updtprv: "
      "btgetprv result %d\n", gnrslt);
   fprintf(stderr,"updtprv: result "
      "1 is usually normal\n", gnrslt);
   fprintf(stderr,"updtprv: check "
      "the output of lstbt.exe\n", gnrslt);
   /* after all updates completed, print the database */
   bthdr->seq = 0;
   btrevers(bthdr,ROOT);
   /* the output of traverse should show 4 z's */
   /* in the beginning of each record */

   /**********************************************************/
   btclose(bthdr);
   return(0);
   } /* main */
